Index: /trunk/src/VBox/Runtime/r0drv/solaris/memobj-r0drv-solaris.c
===================================================================
--- /trunk/src/VBox/Runtime/r0drv/solaris/memobj-r0drv-solaris.c	(revision 4849)
+++ /trunk/src/VBox/Runtime/r0drv/solaris/memobj-r0drv-solaris.c	(revision 4850)
@@ -52,5 +52,5 @@
  * during contiguous allocations (i_ddi_mem_alloc)
  */
-struct ddi_dma_attr g_SolarisX86PhysMemLimits = 
+struct ddi_dma_attr g_SolarisX86PhysMemLimits =
 {
     DMA_ATTR_V0,            /* Version Number */
@@ -116,5 +116,5 @@
             break;
         }
-        
+
         case RTR0MEMOBJTYPE_MAPPING:
         {
@@ -143,5 +143,5 @@
             break;
         }
-        
+
         /* unused */
         case RTR0MEMOBJTYPE_LOW:
@@ -152,5 +152,5 @@
             return VERR_INTERNAL_ERROR;
     }
-    
+
     return VINF_SUCCESS;
 }
@@ -170,5 +170,5 @@
         return VERR_NO_PAGE_MEMORY;
     }
-    
+
     pMemSolaris->Core.pv = virtAddr;
     pMemSolaris->ppShadowPages = NULL;
@@ -189,5 +189,4 @@
             {
                 /* Failed! Fall back to physical contiguous alloc */
-                cmn_err(CE_NOTE, "4G boundary exceeded\n");
                 RTR0MemObjFree(*ppMem, false);
                 rc = rtR0MemObjNativeAllocCont(ppMem, cb, fExecutable);
@@ -219,5 +218,5 @@
     pMemSolaris->Core.pv = virtAddr;
     pMemSolaris->Core.u.Cont.Phys = rtR0MemObjSolarisVirtToPhys(kas.a_hat, virtAddr);
-    pMemSolaris->ppShadowPages = NULL;   
+    pMemSolaris->ppShadowPages = NULL;
     *ppMem = &pMemSolaris->Core;
     return VINF_SUCCESS;
@@ -246,5 +245,5 @@
     if (!pMemSolaris)
         return VERR_NO_MEMORY;
-    
+
     /* There is no allocation here, it needs to be mapped somewhere first */
     pMemSolaris->Core.u.Phys.fAllocated = false;
@@ -265,5 +264,5 @@
     if (R0Process != NIL_RTR0PROCESS)
         userproc = (proc_t *)R0Process;
-    
+
     struct as *useras = userproc->p_as;
     page_t **ppl;
@@ -283,5 +282,5 @@
         return VERR_LOCK_FAILED;
     }
-    
+
     pMemSolaris->Core.u.Lock.R0Process = (RTR0PROCESS)userproc;
     pMemSolaris->ppShadowPages = ppl;
@@ -300,5 +299,5 @@
     caddr_t virtAddr = (caddr_t)((uintptr_t)pv & (uintptr_t)PAGEMASK);
     page_t **ppl;
-    
+
     /* Lock down kernel pages */
     int rc = as_pagelock(&kas, &ppl, virtAddr, cb, S_WRITE);
@@ -336,5 +335,5 @@
 int rtR0MemObjNativeMapKernel(PPRTR0MEMOBJINTERNAL ppMem, RTR0MEMOBJ pMemToMap, void *pvFixed, size_t uAlignment, unsigned fProt)
 {
-    PRTR0MEMOBJSOLARIS pMemToMapSolaris = (PRTR0MEMOBJSOLARIS)pMemToMap;    
+    PRTR0MEMOBJSOLARIS pMemToMapSolaris = (PRTR0MEMOBJSOLARIS)pMemToMap;
     size_t size = pMemToMapSolaris->Core.cb;
     void *pv = pMemToMapSolaris->Core.pv;
@@ -354,5 +353,5 @@
         /* Use user specified address */
         addr = (caddr_t)pvFixed;
-        
+
         /* Blow away any previous mapping */
         as_unmap(&kas, addr, size);
@@ -368,5 +367,5 @@
             return VERR_NO_MEMORY;
         }
-        
+
         /* Check address against alignment, fail if it doesn't match */
         if ((uintptr_t)addr & (uAlignment - 1))
@@ -377,7 +376,7 @@
         }
     }
-    
+
     /* Our protection masks are identical to <sys/mman.h> but we
-     * need to add PROT_USER for the pages to be accessible by user 
+     * need to add PROT_USER for the pages to be accessible by user
      */
     struct segvn_crargs crArgs = SEGVN_ZFOD_ARGS(fProt | PROT_USER, PROT_ALL);
@@ -389,5 +388,5 @@
         return VERR_NO_MEMORY;
     }
-    
+
     /* Map each page into kernel space */
     caddr_t kernAddr = pv;
@@ -411,5 +410,5 @@
 int rtR0MemObjNativeMapUser(PPRTR0MEMOBJINTERNAL ppMem, PRTR0MEMOBJINTERNAL pMemToMap, RTR3PTR R3PtrFixed, size_t uAlignment, unsigned fProt, RTR0PROCESS R0Process)
 {
-    PRTR0MEMOBJSOLARIS pMemToMapSolaris = (PRTR0MEMOBJSOLARIS)pMemToMap;    
+    PRTR0MEMOBJSOLARIS pMemToMapSolaris = (PRTR0MEMOBJSOLARIS)pMemToMap;
     size_t size = pMemToMapSolaris->Core.cb;
     proc_t *userproc = (proc_t *)R0Process;
@@ -431,5 +430,5 @@
         /* Use user specified address */
         addr = (caddr_t)R3PtrFixed;
-        
+
         /* Verify user address (a bit paranoid) */
         rc = valid_usr_range(addr, size, fProt, useras, (caddr_t)USERLIMIT32);
@@ -440,5 +439,5 @@
             return VERR_INVALID_POINTER;
         }
-        
+
         /* Blow away any previous mapping */
         as_unmap(useras, addr, size);
@@ -454,5 +453,5 @@
             return VERR_MAP_FAILED;
         }
-        
+
         /* Check address against alignment, fail if it doesn't match */
         if ((uintptr_t)addr & (uAlignment - 1))
@@ -463,7 +462,7 @@
         }
     }
-    
+
     /* Our protection masks are identical to <sys/mman.h> but we
-     * need to add PROT_USER for the pages to be accessible by user 
+     * need to add PROT_USER for the pages to be accessible by user
      */
     struct segvn_crargs crArgs = SEGVN_ZFOD_ARGS(fProt | PROT_USER, PROT_ALL);
@@ -542,5 +541,5 @@
             else    /* Kernel */
                 hatSpace = kas.a_hat;
-            
+
             uint8_t *pb = (uint8_t *)pMemSolaris->Core.pv + ((size_t)iPage << PAGE_SHIFT);
             return rtR0MemObjSolarisVirtToPhys(hatSpace, pb);